# pytest tests/kh_populator/test_harvest_rsd.py

import json
from rdflib import URIRef
from n4e_kh_schema_py.n4eschema import Person, Organization, SoftwareSourceCode

from kh_populator.harvesting_consumers.rsd_consumer import (
    rsd_software_to_kh_software,
)
from kh_populator.harvesting_searchers.rsd_searcher import (
    SOFTWARE_QUERIES,
    RSDS,
    get_software_from_rsd_instance,
)


def test_get_software_from_rsd_instance():
    for url in RSDS.keys():
        request_url = url + RSDS[url]["endpoint"] + SOFTWARE_QUERIES[0]
        results = get_software_from_rsd_instance(request_url)
        assert len(results) > 0, "response has results"
        for key in [
            "id",
            "slug",
            "brand_name",
            "concept_doi",
            "description",
            "description_url",
            "description_type",
            "get_started_url",
            "is_published",
            "short_statement",
            "created_at",
            "updated_at",
            "image_id",
            "closed_source",
            "project",
            "repository_url",
            "keyword",
            "contributor",
            "organisation",
        ]:
            assert (
                key in results[0].keys()
            ), f"software dictionary has key {key}"


def test_rsd_software_to_kh_software():
    path = "tests/data/rsd.json"
    with open(path) as file:
        rsd_results = json.loads(file.read())
    software_dict = rsd_results[2]
    base_url = list(RSDS.keys())[0]
    software_record = rsd_software_to_kh_software(software_dict, base_url)
    for person in software_record.contributor:
        person.id = "tmp"
        for organization in person.affiliation:
            organization.id = "tmp"
    record_test = SoftwareSourceCode(
        name=["ewatercycle"],
        additionalType=[],
        description=[
            "* Uses containers to run models in an isolated and portable way\n* Rain and sunshine required as input for the models can be generated by the package using ESMValTool\n* Exposes high level API modelled after PyMT to quickly get up and running\n* Has low level API follow the Basic Model Interface (BMI) to couple models together"
        ],
        url=["https://ewatercycle.readthedocs.io/en/stable/"],
        id="tmp",
        contributor=[
            Person(
                name=["Fakhereh Alidoost"],
                id="tmp",
                affiliation=[
                    Organization(
                        id="tmp",
                        name=["Netherlands eScience Center"],
                    )
                ],
            ),
            Person(
                name=["Rolf Hut"],
                id="tmp",
                affiliation=[
                    Organization(
                        id="tmp",
                        name=["Delft University of Technology"],
                    )
                ],
                email="r.w.hut@tudelft.nl",
            ),
            Person(
                name=["Jerom Aerts"],
                id="tmp",
                affiliation=[
                    Organization(
                        id="tmp",
                        name=["Delft University of Technology"],
                        countryName=[],
                    )
                ],
                email=[],
            ),
            Person(
                name=["Barbara Vreede"],
                id="tmp",
                affiliation=[
                    Organization(
                        id="tmp",
                        name=["Netherlands eScience Center"],
                    )
                ],
            ),
            Person(
                name=["Niels  Drost"],
                id="tmp",
                affiliation=[
                    Organization(
                        id="tmp",
                        name=["Netherlands eScience Center"],
                    )
                ],
                email="n.drost@esciencecenter.nl",
            ),
            Person(
                name=["Berend Weel"],
                id="tmp",
                affiliation=[
                    Organization(
                        id="tmp",
                        name=["Netherlands eScience Center"],
                    )
                ],
            ),
            Person(
                name=["Peter Kalverla"],
                id="tmp",
                affiliation=[
                    Organization(
                        id="tmp",
                        name=["Netherlands eScience Center"],
                    )
                ],
                email="p.kalverla@esciencecenter.nl",
            ),
            Person(
                name=["Stef Smeets"],
                id="tmp",
                affiliation=[
                    Organization(
                        id="tmp",
                        name=["Netherlands eScience Center"],
                    )
                ],
                email="s.smeets@esciencecenter.nl",
            ),
            Person(
                name=["Ben van Werkhoven"],
                id="tmp",
                affiliation=[
                    Organization(
                        id="tmp",
                        name=["Netherlands eScience Center"],
                    )
                ],
                email="b.vanwerkhoven@esciencecenter.nl",
            ),
            Person(
                name=["Stefan Verhoeven"],
                id="tmp",
                affiliation=[
                    Organization(
                        id="tmp",
                        name=["Netherlands eScience Center"],
                    )
                ],
                email="s.verhoeven@esciencecenter.nl",
                orcidId="0000-0002-5821-2060",
            ),
        ],
        identifier=[
            "https://doi.org/10.5281/zenodo.5119389",
            "https://research-software-directory.org/software/ewatercycle",
            "88ccae17-87b0-4dab-aa26-346aad7ca424",
        ],
        keywords=[
            "Inter-operability & linked data",
            "Multi-scale & multi model simulations",
            "Optimized data handling",
            "Visualization",
        ],
        codeRepository="https://github.com/eWaterCycle/ewatercycle",
        programmingLanguage=["Python"],
    )
    record_test.license = URIRef("http://spdx.org/licenses/Apache-2.0")
    assert record_test == software_record
